//
// Usage Example:
// bin/scheduler.sh config/groovy-scheduler -Dscript=config/init.groovy
//

import timemachine.scheduler.*
import timemachine.scheduler.jobtask.*
import timemachine.scheduler.service.*

logger.info("This is a Groovy way to explore " + scheduler)

logger.info("Create a scripting job")
jobDef = ScriptingJobTask.createJobDef(
"Groovy",
'''logger.info("We can use Groovy very effectively in scheduler.")''')
jobDef.addSchedule(Schedules.minutely(2))
scheduler.schedule(jobDef)

logger.info("Add a listener on the fly")
class MyJobListener extends JobListenerService {
	void onJobRunAfter(JobContext jobContext) {
		logger.info("Job executed: " + jobContext)
	}
}
scheduler.addUserService(new MyJobListener())

/** We can not do this because scheduler will not be able to find MyTask class ?
logger.info("Create a custom job")
class MyTask implements JobTask {
	static logger = org.slf4j.LoggerFactory.getLogger(MyTask.class)
	void run(JobContext jobContext) {
		logger.info("My Groovy job: ${jobContext}")
	}
}
jobDef = new JobDef().setJobTaskClass(MyTask.class)
jobDef.addSchedule(Schedules.secondly(3))
scheduler.schedule(jobDef)
*/

logger.info("Done.")
